package dnibuilder


final class IPAddressGenerator {
	var int octet4 = 1;
	var int octet3 = 0;
	var int octet2 = 0;
	val int octet1 = 10;
	
	private static IPAddressGenerator instance;
	
	private def IPAddressGenerator IPAddressGenerator(){}
	
	public static def IPAddressGenerator getInstance(){
		if(instance==null){
			return new IPAddressGenerator();
		}
		else{
			return instance;
		}
	}	
	
	public def getNextIP(){
		this.octet4++;
		if(this.octet4==255){
			this.octet4 = 1;
			this.octet3++;
		}
		if(this.octet3==255){
			this.octet4 = 1;
			this.octet3 = 0;
			this.octet2++;
		}
		if(this.octet2==255){
			throw new Exception("Out of IP Addresses!")
		}
		
		return this.octet1+"."+this.octet2+"."+this.octet3+"."+this.octet4
		
	}
}