/**
 */
package tools.descartes.dni.dnimm3ap.impl;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import tools.descartes.dni.dnimm3.NodeType;

import tools.descartes.dni.dnimm3ap.AdaptableEndPerformance;
import tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance;
import tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface;
import tools.descartes.dni.dnimm3ap.AdaptableNode;
import tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance;
import tools.descartes.dni.dnimm3ap.Cost;
import tools.descartes.dni.dnimm3ap.DNIAPPackage;
import tools.descartes.dni.dnimm3ap.NodeAdaptationGroup;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Adaptable Node</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNodeImpl#getCost <em>Cost</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNodeImpl#getEntityType <em>Entity Type</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNodeImpl#getName <em>Name</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNodeImpl#getEndPerformance <em>End Performance</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNodeImpl#getIntermediatePerformance <em>Intermediate Performance</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNodeImpl#getSdnNodePerformance <em>Sdn Node Performance</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNodeImpl#getNetworkInterface <em>Network Interface</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNodeImpl#getAdaptationGroup <em>Adaptation Group</em>}</li>
 * </ul>
 *
 * @generated
 */
public class AdaptableNodeImpl extends MinimalEObjectImpl.Container implements AdaptableNode {
	/**
	 * The cached value of the '{@link #getCost() <em>Cost</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCost()
	 * @generated
	 * @ordered
	 */
	protected EList<Cost> cost;

	/**
	 * The cached value of the '{@link #getEntityType() <em>Entity Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEntityType()
	 * @generated
	 * @ordered
	 */
	protected NodeType entityType;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getEndPerformance() <em>End Performance</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEndPerformance()
	 * @generated
	 * @ordered
	 */
	protected EList<AdaptableEndPerformance> endPerformance;

	/**
	 * The cached value of the '{@link #getIntermediatePerformance() <em>Intermediate Performance</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIntermediatePerformance()
	 * @generated
	 * @ordered
	 */
	protected EList<AdaptableIntermediatePerformance> intermediatePerformance;

	/**
	 * The cached value of the '{@link #getSdnNodePerformance() <em>Sdn Node Performance</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSdnNodePerformance()
	 * @generated
	 * @ordered
	 */
	protected EList<AdaptableSdnNodePerformance> sdnNodePerformance;

	/**
	 * The cached value of the '{@link #getNetworkInterface() <em>Network Interface</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNetworkInterface()
	 * @generated
	 * @ordered
	 */
	protected EList<AdaptableNetworkInterface> networkInterface;

	/**
	 * The cached value of the '{@link #getAdaptationGroup() <em>Adaptation Group</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAdaptationGroup()
	 * @generated
	 * @ordered
	 */
	protected NodeAdaptationGroup adaptationGroup;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdaptableNodeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DNIAPPackage.Literals.ADAPTABLE_NODE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<Cost> getCost() {
		if (cost == null) {
			cost = new EObjectContainmentEList<Cost>(Cost.class, this, DNIAPPackage.ADAPTABLE_NODE__COST);
		}
		return cost;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NodeType getEntityType() {
		if (entityType != null && entityType.eIsProxy()) {
			InternalEObject oldEntityType = (InternalEObject)entityType;
			entityType = (NodeType)eResolveProxy(oldEntityType);
			if (entityType != oldEntityType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, DNIAPPackage.ADAPTABLE_NODE__ENTITY_TYPE, oldEntityType, entityType));
			}
		}
		return entityType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NodeType basicGetEntityType() {
		return entityType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEntityType(NodeType newEntityType) {
		NodeType oldEntityType = entityType;
		entityType = newEntityType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTABLE_NODE__ENTITY_TYPE, oldEntityType, entityType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		NodeType _entityType = this.getEntityType();
		boolean _tripleNotEquals = (_entityType != null);
		if (_tripleNotEquals) {
			return this.getEntityType().getName();
		}
		else {
			return "Unspecified entity type";
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<AdaptableEndPerformance> getEndPerformance() {
		if (endPerformance == null) {
			endPerformance = new EObjectResolvingEList<AdaptableEndPerformance>(AdaptableEndPerformance.class, this, DNIAPPackage.ADAPTABLE_NODE__END_PERFORMANCE);
		}
		return endPerformance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<AdaptableIntermediatePerformance> getIntermediatePerformance() {
		if (intermediatePerformance == null) {
			intermediatePerformance = new EObjectResolvingEList<AdaptableIntermediatePerformance>(AdaptableIntermediatePerformance.class, this, DNIAPPackage.ADAPTABLE_NODE__INTERMEDIATE_PERFORMANCE);
		}
		return intermediatePerformance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<AdaptableSdnNodePerformance> getSdnNodePerformance() {
		if (sdnNodePerformance == null) {
			sdnNodePerformance = new EObjectResolvingEList<AdaptableSdnNodePerformance>(AdaptableSdnNodePerformance.class, this, DNIAPPackage.ADAPTABLE_NODE__SDN_NODE_PERFORMANCE);
		}
		return sdnNodePerformance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<AdaptableNetworkInterface> getNetworkInterface() {
		if (networkInterface == null) {
			networkInterface = new EObjectResolvingEList<AdaptableNetworkInterface>(AdaptableNetworkInterface.class, this, DNIAPPackage.ADAPTABLE_NODE__NETWORK_INTERFACE);
		}
		return networkInterface;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NodeAdaptationGroup getAdaptationGroup() {
		if (adaptationGroup != null && adaptationGroup.eIsProxy()) {
			InternalEObject oldAdaptationGroup = (InternalEObject)adaptationGroup;
			adaptationGroup = (NodeAdaptationGroup)eResolveProxy(oldAdaptationGroup);
			if (adaptationGroup != oldAdaptationGroup) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, DNIAPPackage.ADAPTABLE_NODE__ADAPTATION_GROUP, oldAdaptationGroup, adaptationGroup));
			}
		}
		return adaptationGroup;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NodeAdaptationGroup basicGetAdaptationGroup() {
		return adaptationGroup;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetAdaptationGroup(NodeAdaptationGroup newAdaptationGroup, NotificationChain msgs) {
		NodeAdaptationGroup oldAdaptationGroup = adaptationGroup;
		adaptationGroup = newAdaptationGroup;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTABLE_NODE__ADAPTATION_GROUP, oldAdaptationGroup, newAdaptationGroup);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAdaptationGroup(NodeAdaptationGroup newAdaptationGroup) {
		if (newAdaptationGroup != adaptationGroup) {
			NotificationChain msgs = null;
			if (adaptationGroup != null)
				msgs = ((InternalEObject)adaptationGroup).eInverseRemove(this, DNIAPPackage.NODE_ADAPTATION_GROUP__ITEMS, NodeAdaptationGroup.class, msgs);
			if (newAdaptationGroup != null)
				msgs = ((InternalEObject)newAdaptationGroup).eInverseAdd(this, DNIAPPackage.NODE_ADAPTATION_GROUP__ITEMS, NodeAdaptationGroup.class, msgs);
			msgs = basicSetAdaptationGroup(newAdaptationGroup, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTABLE_NODE__ADAPTATION_GROUP, newAdaptationGroup, newAdaptationGroup));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case DNIAPPackage.ADAPTABLE_NODE__ADAPTATION_GROUP:
				if (adaptationGroup != null)
					msgs = ((InternalEObject)adaptationGroup).eInverseRemove(this, DNIAPPackage.NODE_ADAPTATION_GROUP__ITEMS, NodeAdaptationGroup.class, msgs);
				return basicSetAdaptationGroup((NodeAdaptationGroup)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case DNIAPPackage.ADAPTABLE_NODE__COST:
				return ((InternalEList<?>)getCost()).basicRemove(otherEnd, msgs);
			case DNIAPPackage.ADAPTABLE_NODE__ADAPTATION_GROUP:
				return basicSetAdaptationGroup(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case DNIAPPackage.ADAPTABLE_NODE__COST:
				return getCost();
			case DNIAPPackage.ADAPTABLE_NODE__ENTITY_TYPE:
				if (resolve) return getEntityType();
				return basicGetEntityType();
			case DNIAPPackage.ADAPTABLE_NODE__NAME:
				return getName();
			case DNIAPPackage.ADAPTABLE_NODE__END_PERFORMANCE:
				return getEndPerformance();
			case DNIAPPackage.ADAPTABLE_NODE__INTERMEDIATE_PERFORMANCE:
				return getIntermediatePerformance();
			case DNIAPPackage.ADAPTABLE_NODE__SDN_NODE_PERFORMANCE:
				return getSdnNodePerformance();
			case DNIAPPackage.ADAPTABLE_NODE__NETWORK_INTERFACE:
				return getNetworkInterface();
			case DNIAPPackage.ADAPTABLE_NODE__ADAPTATION_GROUP:
				if (resolve) return getAdaptationGroup();
				return basicGetAdaptationGroup();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case DNIAPPackage.ADAPTABLE_NODE__COST:
				getCost().clear();
				getCost().addAll((Collection<? extends Cost>)newValue);
				return;
			case DNIAPPackage.ADAPTABLE_NODE__ENTITY_TYPE:
				setEntityType((NodeType)newValue);
				return;
			case DNIAPPackage.ADAPTABLE_NODE__END_PERFORMANCE:
				getEndPerformance().clear();
				getEndPerformance().addAll((Collection<? extends AdaptableEndPerformance>)newValue);
				return;
			case DNIAPPackage.ADAPTABLE_NODE__INTERMEDIATE_PERFORMANCE:
				getIntermediatePerformance().clear();
				getIntermediatePerformance().addAll((Collection<? extends AdaptableIntermediatePerformance>)newValue);
				return;
			case DNIAPPackage.ADAPTABLE_NODE__SDN_NODE_PERFORMANCE:
				getSdnNodePerformance().clear();
				getSdnNodePerformance().addAll((Collection<? extends AdaptableSdnNodePerformance>)newValue);
				return;
			case DNIAPPackage.ADAPTABLE_NODE__NETWORK_INTERFACE:
				getNetworkInterface().clear();
				getNetworkInterface().addAll((Collection<? extends AdaptableNetworkInterface>)newValue);
				return;
			case DNIAPPackage.ADAPTABLE_NODE__ADAPTATION_GROUP:
				setAdaptationGroup((NodeAdaptationGroup)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case DNIAPPackage.ADAPTABLE_NODE__COST:
				getCost().clear();
				return;
			case DNIAPPackage.ADAPTABLE_NODE__ENTITY_TYPE:
				setEntityType((NodeType)null);
				return;
			case DNIAPPackage.ADAPTABLE_NODE__END_PERFORMANCE:
				getEndPerformance().clear();
				return;
			case DNIAPPackage.ADAPTABLE_NODE__INTERMEDIATE_PERFORMANCE:
				getIntermediatePerformance().clear();
				return;
			case DNIAPPackage.ADAPTABLE_NODE__SDN_NODE_PERFORMANCE:
				getSdnNodePerformance().clear();
				return;
			case DNIAPPackage.ADAPTABLE_NODE__NETWORK_INTERFACE:
				getNetworkInterface().clear();
				return;
			case DNIAPPackage.ADAPTABLE_NODE__ADAPTATION_GROUP:
				setAdaptationGroup((NodeAdaptationGroup)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case DNIAPPackage.ADAPTABLE_NODE__COST:
				return cost != null && !cost.isEmpty();
			case DNIAPPackage.ADAPTABLE_NODE__ENTITY_TYPE:
				return entityType != null;
			case DNIAPPackage.ADAPTABLE_NODE__NAME:
				return NAME_EDEFAULT == null ? getName() != null : !NAME_EDEFAULT.equals(getName());
			case DNIAPPackage.ADAPTABLE_NODE__END_PERFORMANCE:
				return endPerformance != null && !endPerformance.isEmpty();
			case DNIAPPackage.ADAPTABLE_NODE__INTERMEDIATE_PERFORMANCE:
				return intermediatePerformance != null && !intermediatePerformance.isEmpty();
			case DNIAPPackage.ADAPTABLE_NODE__SDN_NODE_PERFORMANCE:
				return sdnNodePerformance != null && !sdnNodePerformance.isEmpty();
			case DNIAPPackage.ADAPTABLE_NODE__NETWORK_INTERFACE:
				return networkInterface != null && !networkInterface.isEmpty();
			case DNIAPPackage.ADAPTABLE_NODE__ADAPTATION_GROUP:
				return adaptationGroup != null;
		}
		return super.eIsSet(featureID);
	}

} //AdaptableNodeImpl
