package tools.descartes.dni.dnimm3.tools;

import java.io.File;

import org.junit.Assert;
import org.junit.Test;

import tools.descartes.dni.dnimm3.impl.NetworkInfrastructureImpl;

public class UtilTest {

	@Test
	public void shouldCloneModel() {
		File file = new File("resources-test/scenario0B.dni");
		NetworkInfrastructureImpl networkInfrastructure1 = DNIParser.convertToModel(file);
		NetworkInfrastructureImpl networkInfrastructure2 = DNIUtil.cloneModel(networkInfrastructure1);
		Assert.assertNotEquals(networkInfrastructure1, networkInfrastructure2);
		Assert.assertEquals(networkInfrastructure1.getStructure().getNodes().size(),
				networkInfrastructure2.getStructure().getNodes().size());
		Assert.assertEquals(networkInfrastructure1.getStructure().getNodes().get(0).getUid_generated(),
				networkInfrastructure2.getStructure().getNodes().get(0).getUid_generated());
	}

}
